unit RenderToTex1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,

  OpenGL12, AppEvnts, glFont, ExtCtrls;

type
  TForm1 = class(TForm)
    ApplicationEvents1: TApplicationEvents;
    RotTimer: TTimer;
    FrameTimer: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure ApplicationEvents1Idle(Sender: TObject; var Done: Boolean);
    procedure FormResize(Sender: TObject);
    procedure RotTimerTimer(Sender: TObject);
    procedure FrameTimerTimer(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1       : TForm1;
  Rot         : Single;
  Frames      : Integer;
  FPS         : Integer;
  Texture     : Cardinal;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var
 DummyPal : HPalette;
 TmpData  : Pointer;
begin
DC := GetDC(Handle);
RC := CreateRenderingContext(DC, [opDoubleBuffered], 32, 24, 0, 0, 0, 0, DummyPal);
ActivateRenderingContext(DC, RC);
glEnable(GL_TEXTURE_2D);
glClearColor(0,0,1,0);
ErstelleBitmapFont(BitFont, 'Arial');

// Neue Textur erstellen Gre : 128x128 Pixel
GetMem(TmpData, 128*128*4);
glGenTextures(1, @Texture);
glBindTexture(GL_TEXTURE_2D, Texture);
glTexImage2D(GL_TEXTURE_2D, 0, 4, 128, 128, 0, GL_RGBA, GL_UNSIGNED_BYTE, TmpData);
glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
Dispose(TmpData);

DeActivateRenderingContext;
end;

procedure TForm1.ApplicationEvents1Idle(Sender: TObject;
  var Done: Boolean);
begin
Done := False;
ActivateRenderingContext(DC, RC);
// Textur mit Text erstellen "Render to Texture"
// Viewportgre der Texturengre anpassen
// Orthographische Ansicht
glMatrixMode(GL_PROJECTION);
glLoadIdentity;
glViewport(0,0,128,128);
glOrtho(0,640,480,0,-1,1);
glMatrixMode(GL_MODELVIEW);
glLoadIdentity();
glClearColor(0,0,0,0);
glClear(GL_COLOR_BUFFER_BIT or  GL_DEPTH_BUFFER_BIT);
glStartBitmapText(640,480);
 glPrintBitmapTextEx(BitFont, 230, 240, TimeToStr(Now));
glEndBitmapText;

// Viewport in die Textur kopieren
glBindTexture(GL_TEXTURE_2D, Texture);
glCopyTexImage2D(GL_TEXTURE_2D, 0, GL_RGB8, 0, 0, 128, 128, 0);

// Szene zeichnen
glViewport(0, 0, ClientWidth, ClientHeight);
glMatrixMode(GL_PROJECTION);
glLoadIdentity;
gluPerspective(45, ClientWidth/ClientHeight, 0.1, 100);
glMatrixMode(GL_MODELVIEW);
glClearColor(0,0,1,0);
glClear(GL_COLOR_BUFFER_BIT or  GL_DEPTH_BUFFER_BIT);
glLoadIdentity;
glRotatef(Rot, 0, 0, 1);

glBindTexture(GL_TEXTURE_2D, Texture);
glBegin(GL_QUADS);
 glTexCoord2f(0,0); glVertex3f(-1, -1, -4);
 glTexCoord2f(1,0); glVertex3f( 1, -1, -4);
 glTexCoord2f(1,1); glVertex3f( 1,  1, -4);
 glTexCoord2f(0,1); glVertex3f(-1,  1, -4);
glEnd;

//FPS anzeigen
glMatrixMode(GL_PROJECTION);
glLoadIdentity;
glOrtho(0,640,480,0,-1,1);
glMatrixMode(GL_MODELVIEW);
glLoadIdentity();
glClearColor(0,0,0,0);
glStartBitmapText(640,480);
 glPrintBitmapTextEx(BitFont, 10, 15, IntToStr(FPS)+'FPS');
glEndBitmapText;

SwapBuffers(DC);
DeActivateRenderingContext;
inc(Frames);
end;

procedure TForm1.FormResize(Sender: TObject);
begin
if (HandleAllocated) and (DC > 0) and (RC > 0) then
 begin
 ActivateRenderingContext(DC, RC);
 glViewport(0, 0, ClientWidth, ClientHeight);
 glMatrixMode(GL_PROJECTION);
 glLoadIdentity;
 gluPerspective(45, ClientWidth/ClientHeight, 0.1, 100);
 DeactivateRenderingContext;
 end;
end;

procedure TForm1.RotTimerTimer(Sender: TObject);
begin
Rot := Rot+1;
if Rot > 360 then
 Rot := 0;
end;

procedure TForm1.FrameTimerTimer(Sender: TObject);
begin
FPS    := Frames;
Frames := 0;
end;

end.
